/*******************************************************************************
 * Copyright (c) 2010, 2013 Tasktop Technologies
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Tasktop Technologies - initial API and implementation
 ******************************************************************************/
package com.tasktop.c2c.server.common.service;

import java.io.IOException;

import ch.ethz.ssh2.Connection;

/**
 * Creates and authenticates an SSH connection.
 * 
 * @author mhawkins
 */
public abstract class SshConnectionFactory {
	private String sshUser;

	public SshConnectionFactory() {
	}

	public SshConnectionFactory(String sshUser) {
		this.sshUser = sshUser;
	}

	public Connection connect(String host) throws IOException {
		return connect(host, 0, 0);
	}

	public abstract Connection connect(String host, int connectTimeout, int kexTimeout) throws IOException;

	public final boolean authenticate(Connection connection) throws IOException {
		return authenticate(connection, sshUser);
	}

	protected abstract boolean authenticate(Connection conneciton, String sshUser) throws IOException;

	public final void setSshUser(String sshUser) {
		this.sshUser = sshUser;
	}
}
